#include <iostream>
#include <fstream>
#include <string>

using namespace std;

bool is_valid(string s) {
    int n = s.size();
    s += "11";
    for (int i = 0; i < n; i++) {
        if (s[i] == '2' && s[i + 1] == '2') return false;
        if (s[i] == '3' && s[i + 2] == '3') return false;
    }

    return true;
}

int main(int argc, char** argv) {
    ifstream input(argv[1]);
    ifstream output(argv[2]);
    ifstream answer(argv[3]);

    int t;
    input >> t;

    int score = 0;
    bool pe = false;
    while (t--) {
        int cx, cy, cz;
        input >> cx >> cy >> cz;

        string s;

        if (!getline(output, s)) {
            break;
        }

        string ans;
        getline(answer, ans);
        if (s == "impossible") {
            if (ans == "impossible") {
                score++;
            }
            continue;
        }

        if (s[0] == '0') {
            continue;
        }

        for (int i = 0; i < s.size(); i++) {
            if (s[i] == '1') cx--;
            else if (s[i] == '2') cy--;
            else if (s[i] == '3') cz--;
            else  {
                cout << "Wrong output symbols" << endl;
                exit(2);
            }
        }

        if (cx != 0 || cy != 0 || cz != 0) {
            continue;
        }

        if (is_valid(s)) {
            score++;

        }
    }

    cout << score << endl;
}