#include <iostream>
#include <algorithm>
#include <string>
#include <sstream>

using namespace std;

int used[4][4][51][51][51];
stringstream ss;

bool dfs(int l, int pl, int cx, int cy, int cz) {
    if (used[l][pl][cx][cy][cz]) {
        return false;
    }

    used[l][pl][cx][cy][cz] = true;

    if (cx == 0 && cy == 0 && cz == 0) {
        return true;
    }

    if (cx && dfs(1, l, cx - 1, cy, cz)) {
        ss << '1';
        return true;
    }

    if (cy && l != 2 && dfs(2, l, cx, cy - 1, cz)) {
        ss << '2';
        return true;
    }
    if (cz && l != 3 && pl != 3 && dfs(3, l, cx, cy, cz - 1)) {
        ss << '3';
        return true;
    }

    return false;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int t;
    cin >> t;

    while (t--) {
        int cx, cy, cz;
        cin >> cx >> cy >> cz;

        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                for (int k = 0; k < 51; k++) {
                    for (int p = 0; p < 51; p++) {
                        for (int q = 0; q < 51; q++) {
                            used[i][j][k][p][q] = false;
                        }
                    }
                }
            }
        }

        ss.str("");

        if (dfs(0, 0, cx, cy, cz)) {
            string s = ss.str();
            reverse(s.begin(), s.end());
            cout << s << endl;
        } else {
            cout << "impossible" << endl;
        }
    }
}